Get an ownership inference by owner type

Note: This endpoint is in Preview and may be subject to change. If you have any feedback, contact Datadog support.

GET https://api.ap1.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.ap2.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.datadoghq.eu/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.ddog-gov.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.us2.ddog-gov.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.uk1.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.us3.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}https://api.us5.datadoghq.com/api/v2/csm/ownership/{resource_id}/{owner_type}

Overview

Get the current ownership inference for a resource for a specific owner type.

This endpoint supports ETag-based caching. Pass the previously returned ETag value in the If-None-Match request header to receive a 304 Not Modified response when the inference has not changed.

Arguments

Path Parameters

Name

Type

Description

resource_id [required]

string

The identifier of the resource to retrieve the ownership inference for.

owner_type [required]

string

The owner type of the inference to retrieve.

Header Parameters

Name

Type

Description

If-None-Match

string

A previously returned ETag value. When supplied and the resource has not changed, the endpoint returns 304 Not Modified.

Response

OK

The response returned when retrieving a single ownership inference for an owner type.

Expand All

Field

Type

Description

data [required]

object

The data wrapper for a single ownership inference response.

attributes [required]

object

The attributes of a single ownership inference.

checksum [required]

string

A checksum that uniquely identifies the current state of the inference. Required when submitting feedback.

confidence [required]

string

The confidence score of the inference, expressed as a numeric string with up to four decimal places.

created_at [required]

date-time

The time when the inference was created.

evidence_versions [required]

[object]

The list of evidence versions associated with an inference.

explanation [required]

string

A human-readable explanation of how the inference was produced.

owner_type [required]

enum

The owner type for an ownership inference. Allowed enum values: user,team,service,unknown

primary_contact_ref

string

The primary contact reference for the inferred owner, formatted as ref:handle/<owner_handle>.

sources [required]

[object]

The list of sources backing an ownership inference. Empty when the inference status is not whitelisted to expose sources.

status [required]

enum

The lifecycle status of an ownership inference. Allowed enum values: suggested,persisted,overridden,failed,unknown

updated_at [required]

date-time

The time when the inference was last updated.

id [required]

string

The identifier of the inference, formatted as resource_id:owner_type.

type [required]

enum

The type of the ownership inference resource. The value should always be ownership_inference. Allowed enum values: ownership_inference

default: ownership_inference

{
  "data": {
    "attributes": {
      "checksum": "abc123",
      "confidence": "0.9500",
      "created_at": "2026-01-15T10:00:00Z",
      "evidence_versions": [
        []
      ],
      "explanation": "High confidence match",
      "owner_type": "team",
      "primary_contact_ref": "ref:handle/team-a",
      "sources": [
        []
      ],
      "status": "suggested",
      "updated_at": "2026-01-15T10:00:00Z"
    },
    "id": "test-resource:team",
    "type": "ownership_inference"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  # Path parameters
export resource_id="test-resource"
export owner_type="team"
# Curl command
curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/csm/ownership/${resource_id}/${owner_type}" \ -H "Accept: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}"
"""
Get an ownership inference by owner type returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.csm_ownership_api import CSMOwnershipApi
from datadog_api_client.v2.model.ownership_owner_type import OwnershipOwnerType

configuration = Configuration()
configuration.unstable_operations["get_ownership_inference"] = True
with ApiClient(configuration) as api_client:
    api_instance = CSMOwnershipApi(api_client)
    response = api_instance.get_ownership_inference(
        resource_id="test-resource",
        owner_type=OwnershipOwnerType.TEAM,
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# Get an ownership inference by owner type returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_ownership_inference".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CSMOwnershipAPI.new
p api_instance.get_ownership_inference("test-resource", OwnershipOwnerType::TEAM)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// Get an ownership inference by owner type returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetOwnershipInference", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCSMOwnershipApi(apiClient)
	resp, r, err := api.GetOwnershipInference(ctx, "test-resource", datadogV2.OWNERSHIPOWNERTYPE_TEAM, *datadogV2.NewGetOwnershipInferenceOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CSMOwnershipApi.GetOwnershipInference`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CSMOwnershipApi.GetOwnershipInference`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// Get an ownership inference by owner type returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CsmOwnershipApi;
import com.datadog.api.client.v2.model.OwnershipInferenceResponse;
import com.datadog.api.client.v2.model.OwnershipOwnerType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getOwnershipInference", true);
    CsmOwnershipApi apiInstance = new CsmOwnershipApi(defaultClient);

    try {
      OwnershipInferenceResponse result =
          apiInstance.getOwnershipInference("test-resource", OwnershipOwnerType.TEAM);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CsmOwnershipApi#getOwnershipInference");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// Get an ownership inference by owner type returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_csm_ownership::CSMOwnershipAPI;
use datadog_api_client::datadogV2::api_csm_ownership::GetOwnershipInferenceOptionalParams;
use datadog_api_client::datadogV2::model::OwnershipOwnerType;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetOwnershipInference", true);
    let api = CSMOwnershipAPI::with_config(configuration);
    let resp = api
        .get_ownership_inference(
            "test-resource".to_string(),
            OwnershipOwnerType::TEAM,
            GetOwnershipInferenceOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Get an ownership inference by owner type returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getOwnershipInference"] = true;
const apiInstance = new v2.CSMOwnershipApi(configuration);

const params: v2.CSMOwnershipApiGetOwnershipInferenceRequest = {
  resourceId: "test-resource",
  ownerType: "team",
};

apiInstance
  .getOwnershipInference(params)
  .then((data: v2.OwnershipInferenceResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"